﻿
Public Class Form1

    Friend wp1 As WavePlayer = New WavePlayer

    Private Sub Form_Main_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ----------------------------------------------------------------
        Me.Text = AppTitleAndVersion()
        ' ---------------------------------------------------------------- 
        Combo_InitFromEnum(cmb_WaveType, GetType(WavePlayer.WaveTypes))
        cmb_WaveType.SelectedIndex = 0
        Load_INI()
        WaveGenSetWaveTypes()
        wp1.SetVolumeOut(tbar_VolumeOut.Value)
        wp1.SetVolumeDrive(tbar_VolumeDrive.Value)
        wp1.SetFreq(tbar_FreqMin.Value, tbar_FreqMax.Value)
        ComboBox_VideoInputDevice_InitWithCurrentDeviceName()
        FillAudioOutDevicesCombo()
        SetLocales()
        UpdateUserInterface()
        ' ---------------------------------------------------------------- CAPTURE
        CaptureStartStop()
        ProcessImage_SetParams()
        ' ---------------------------------------------------------------- DOCK
        If Form_VideoInControls_VisibleAtStart Then
            Form_VideoInControls.Show(Me)
        Else
            Form_VideoInControls.Show(Me)
            Form_VideoInControls.Visible = False
        End If
        DockAllWindows()
        ' ----------------------------------------------------------------
        ToolStrip1.Renderer = New ToolStripButtonRenderer
        ' ---------------------------------------------------------------- Main Timer
        Timer1.Interval = 50
        Timer1.Start()
        ' ----------------------------------------------------------------
        SetDefaultFocus()
        EventsAreEnabled = True
        ' ---------------------------------------------------------------- SHOW
        Refresh()
        Forms_FadeTo(1, 400)
        ' ---------------------------------------------------------------- 
        If chk_AudioEnabled.Checked Then
            wp1.PlayStart(SelectedAudioOut)
        Else
            wp1.PlayStop()
        End If
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Not EventsAreEnabled Then Return
        CloseProgram()
    End Sub

    Private Sub CloseProgram()
        Save_INI()
        EventsAreEnabled = False
        Forms_FadeTo(0, 500)
        Me.Refresh()
        Timer1.Stop()
        wp1.PlayStop()
        Capture_STOP()
        Form_VideoInControls.Close()
        Me.Close()
    End Sub

    Private Sub Form1_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    Private Sub Form_Main_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        DockAllWindows()
    End Sub

    Private Sub Form_Main_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        If Not EventsAreEnabled Then Return
        DockAllWindows()
    End Sub

    Private Sub SetDefaultFocus()
        PBox_Camera.Focus()
    End Sub

    Friend Sub PictureBox1_Clear()
        PBox_Camera.Image = PBox_Camera.InitialImage
    End Sub

    Friend Sub DockAllWindows()
        Form_VideoInControls.SetSnap()
    End Sub

    Private Sub OpenCloseFormVideoInControls()
        If Form_VideoInControls.Visible Then
            Form_VideoInControls.Visible = False
        Else
            Form_VideoInControls.Visible = True
            Me.Focus()
        End If
        DockAllWindows()
    End Sub

    Private Sub UpdateUserInterface()
        ' ready for language string not already updated
        Refresh()
    End Sub

    Private Sub chk_Gen1_enable_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles chk_AudioEnabled.CheckedChanged
        If Not EventsAreEnabled Then Return
        If chk_AudioEnabled.Checked Then
            wp1.PlayStart(SelectedAudioOut)
        Else
            wp1.PlayStop()
        End If
    End Sub


    ' ===================================================================================
    '   MenuStrip and ToolStrip Gradients
    ' ===================================================================================
    Private Sub MenuStrip1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MenuStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    MenuStrip1.Width, MenuStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.FromArgb(230, 230, 230), _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Horizontal)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub
    Private Sub ToolStrip1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles ToolStrip1.Paint
        Dim bounds As New Rectangle(0, 0, _
                                    ToolStrip1.Width, ToolStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                       Color.White, _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, bounds)
    End Sub

    ' ===================================================================================
    '   ToolStrip PressedButton color
    ' ===================================================================================
    Class ToolStripButtonRenderer
        Inherits System.Windows.Forms.ToolStripProfessionalRenderer
        Protected Overrides Sub OnRenderButtonBackground(ByVal e As ToolStripItemRenderEventArgs)
            Dim btn As ToolStripButton = CType(e.Item, ToolStripButton)
            If btn IsNot Nothing AndAlso btn.CheckOnClick AndAlso btn.Checked Then
                Dim bounds As Rectangle = New Rectangle(0, 0, e.Item.Width - 1, e.Item.Height - 1)
                Dim brush As New Drawing2D.LinearGradientBrush(bounds, _
                                                               Color.Gold, _
                                                               Color.FromArgb(250, 250, 250), _
                                                               Drawing2D.LinearGradientMode.Vertical)
                e.Graphics.FillRectangle(brush, bounds)
                e.Graphics.DrawRectangle(Pens.Orange, bounds)
            Else
                MyBase.OnRenderButtonBackground(e)
            End If
        End Sub
    End Class

    ' ===================================================================================
    '  MenuStrip and ToolStrip accepting the first click
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message
    ' ===================================================================================
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub


    ' =======================================================================================
    '   MENU FILE
    ' =======================================================================================
    Private Sub Menu_Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_Exit.Click
        CloseProgram()
    End Sub

    ' =======================================================================================
    '   MENU TOOLS
    ' =======================================================================================
    Private Sub Menu_VideoinControls_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Tools_VideoinControls.Click
        OpenCloseFormVideoInControls()
    End Sub

    ' =======================================================================================
    '   MENU LANGUAGE
    ' =======================================================================================
    Private Sub Menu_Language_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language.DropDownOpening
        For Each item As ToolStripMenuItem In Menu_Language.DropDownItems
            If item.Name.EndsWith(Language, StringComparison.InvariantCultureIgnoreCase) Then
                item.Select()
            End If
        Next
    End Sub
    Private Sub Menu_Language_DEU_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_DEU.Click
        Language = "DEU"
        SetLocales()
        Save_INI()
        UpdateUserInterface()
    End Sub
    Private Sub Menu_Language_ENG_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_ENG.Click
        Language = "ENG"
        SetLocales()
        Save_INI()
        UpdateUserInterface()
    End Sub
    Private Sub Menu_Language_ESP_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_ESP.Click
        Language = "ESP"
        SetLocales()
        Save_INI()
        UpdateUserInterface()
    End Sub
    Private Sub Menu_Language_FRA_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_FRA.Click
        Language = "FRA"
        SetLocales()
        Save_INI()
        UpdateUserInterface()
    End Sub
    Private Sub Menu_Language_ITA_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_ITA.Click
        Language = "ITA"
        SetLocales()
        Save_INI()
        UpdateUserInterface()
    End Sub
    Private Sub Menu_Language_JPN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Language_JPN.Click
        Language = "JPN"
        SetLocales()
        Save_INI()
        UpdateUserInterface()
    End Sub

    ' =======================================================================================
    '   MENU HELP
    ' =======================================================================================
    Private Sub Menu_Help_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Help.DropDownOpening
        SetLocales()
    End Sub
    Private Sub Menu_Help_ProgramHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ProgramHelp.Click
        OpenLocalizedHelp("Theremino_View_Help", ".pdf")
    End Sub
    Private Sub Menu_Help_OpenProgramFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_OpenProgramFolder.Click
        Process.Start(Application.StartupPath)
    End Sub
    Private Sub OpenLocalizedHelp(ByVal name As String, Optional ByVal ext As String = ".rtf")
        Dim fname As String = Application.StartupPath & "\Docs\" & name & "_" & Language & ext
        If FileExists(fname) Then
            Process.Start(fname)
        Else
            fname = Application.StartupPath & "\Docs\" & name & "_ENG" & ext
            If FileExists(fname) Then
                Process.Start(fname)
            Else
                fname = Application.StartupPath & "\Docs\" & name & "_ITA" & ext
                If FileExists(fname) Then
                    Process.Start(fname)
                Else
                    fname = Application.StartupPath & "\Docs\" & name & ext
                    If FileExists(fname) Then
                        Process.Start(fname)
                    End If
                End If
            End If
        End If
    End Sub

    ' =======================================================================================
    '   MENU ABOUT
    ' =======================================================================================
    Private Sub Menu_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_About.Click
        Form_About.ShowDialog(Me)
    End Sub

    ' =======================================================================================
    '   TOOLSTRIP
    ' =======================================================================================
    Private Sub Tool_VideoInControls_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_VideoControls.Click
        OpenCloseFormVideoInControls()
    End Sub
    Private Sub ToolStrip1_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStrip1.MouseEnter
        Me.Focus() ' with this the toolstrip responds always at the first click
    End Sub

    ' ==============================================================================================================
    '   COMBO BOX - VIDEO INPUT
    ' ==============================================================================================================
    Private Sub ComboBox_VideoInputDevice_InitWithCurrentDeviceName()
        Combo_Init(ComboBox_VideoInputDevice, VideoInDevice)
    End Sub
    Private Sub ComboBox_VideoInputDevice_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_VideoInputDevice.DropDownClosed
        SetDefaultFocus()
    End Sub
    Private Sub ComboBox_VideoInputDevice_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox_VideoInputDevice.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        VideoInDevice = Combo_GetValue(ComboBox_VideoInputDevice)
        Timer1.Stop()
        Application.DoEvents()
        Capture_STOP()
        Application.DoEvents()
        Capture_INIT(VideoInDevice)
        Capture_ConnectFiltersAndRun()
        Timer1.Start()
        SetDefaultFocus()
        Save_INI()
        If Form_VideoInControls.Visible Then
            Form_VideoInControls.UpdateAllValues()
            Form_VideoInControls.Focus()
        End If
    End Sub
    Private Sub ComboBox_VideoInputDevice_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_VideoInputDevice.DropDown
        Dim fnames() As String
        fnames = EnumFiltersByCategory(FilterCategory.VideoInputDevice)
        With ComboBox_VideoInputDevice
            .Items.Clear()
            For Each fltName As String In fnames
                .Items.Add(fltName)
            Next
            Combo_SetIndex_FromString(ComboBox_VideoInputDevice, VideoInDevice)
        End With
    End Sub

    ' ===================================================================================================
    '  SELECT AUDIO OUTPUT 
    ' ===================================================================================================
    Friend SelectedAudioOut As Int32 = 0
    Private Sub cmb_AudioOutDevices_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioOutDevices.DropDown
        cmb_AudioOutDevices.ItemHeight = 16
        FillAudioOutDevicesCombo()
    End Sub
    Private Sub ccmb_AudioOutDevices_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioOutDevices.DropDownClosed
        cmb_AudioOutDevices.ItemHeight = 11
        SelectedAudioOut = cmb_AudioOutDevices.SelectedIndex
        If chk_AudioEnabled.Checked Then
            wp1.PlayStart(SelectedAudioOut)
        Else
            wp1.PlayStop()
        End If
    End Sub
    Private Sub FillAudioOutDevicesCombo()
        Dim sa As String() = WaveNative.GetOutputDevicesNames
        If sa.Length = 0 Then ReDim sa(0) : sa(0) = ""
        cmb_AudioOutDevices.Items.Clear()
        For i As Int32 = 0 To sa.Length - 1
            cmb_AudioOutDevices.Items.Add(ExtractDeviceName(sa(i)))
        Next
        Combo_SetIndex(cmb_AudioOutDevices, SelectedAudioOut)
    End Sub

    ' ===================================================================================================
    '  AUDIO IN OUT HELPERS
    ' ===================================================================================================
    Private Sub btn_AudioOutputs_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_AudioOutputs.ClickButtonArea
        Open_AudioOutputs()
    End Sub
    Private Function ExtractDeviceName(ByVal s As String) As String
        If s = Nothing Then Return ""
        Dim i As Int32 = InStr(s, "(") - 1
        If i > 1 Then s = s.Remove(i)
        Return s.Trim
    End Function

    ' ==============================================================================================================
    '   BUTTONS AND COMMANDS
    ' ==============================================================================================================
    Private Sub btn_MouseTest_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles chk_MouseTest.ClickButtonArea
        CaptureStartStop()
    End Sub

    Private Sub CaptureStartStop()
        If chk_MouseTest.Checked Then
            Capture_STOP()
        Else
            Capture_INIT(VideoInDevice)
            If VideoCaptureDevice_Is_VFW() Then
                Capture_ConnectFiltersAndRun()
            Else
                Capture_SetVideoFormatParams()
            End If
        End If
    End Sub

    Private Sub cmb_Gen1_Wave_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_WaveType.DropDown
        CType(sender, ComboBox).ItemHeight = 16
    End Sub
    Private Sub cmb_Gen1_Wave_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_WaveType.DropDownClosed
        CType(sender, ComboBox).ItemHeight = 12
    End Sub
    Private Sub cmb_Gen1_Wave_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_WaveType.SelectionChangeCommitted
        If Not EventsAreEnabled Then Return
        WaveGenSetWaveTypes()
        Save_INI()
    End Sub
    Private Sub WaveGenSetWaveTypes()
        wp1.SetWaveType(CType(cmb_WaveType.SelectedIndex, WavePlayer.WaveTypes))
    End Sub

    ' ==============================================================================================================
    '   PARAMS
    ' ==============================================================================================================
    Private Sub Params_LostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_FlipX.LostFocus, _
                                                                                                     chk_FlipY.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub FlipParams_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_FlipX.CheckedChanged, _
                                                                                                       chk_FlipY.CheckedChanged
        If Not EventsAreEnabled Then Return
        ProcessImage_SetParams()
    End Sub

    Private Sub FrequencyParams_Changed(ByVal sender As Object, ByVal e As System.EventArgs) Handles tbar_FreqMin.ValueChanged, _
                                                                                                       tbar_FreqMax.ValueChanged
        If Not EventsAreEnabled Then Return
        wp1.SetFreq(tbar_FreqMin.Value, tbar_FreqMax.Value)
    End Sub

    Private Sub tbar_VolumeOut_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tbar_VolumeOut.ValueChanged
        If Not EventsAreEnabled Then Return
        wp1.SetVolumeOut(tbar_VolumeOut.Value)
    End Sub
    Private Sub tbar_VolumeDrive_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tbar_VolumeDrive.ValueChanged
        If Not EventsAreEnabled Then Return
        wp1.SetVolumeDrive(tbar_VolumeDrive.Value)
    End Sub


    ' ==============================================================================================================
    '   CAPTURE TIMER
    ' ==============================================================================================================
    Private Timer1_Working As Boolean = False
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return
        If chk_MouseTest.Checked Then
            MouseTest()
            ProcessImage_ToUserInterface()
        Else
            ProcessImage_ToUserInterface()
        End If
        CtrlKeyPressed = My.Computer.Keyboard.CtrlKeyDown
    End Sub

    Private Sub MouseTest()
        If MouseButtonLeftPressed() Then
            Dim p As Point = Control.MousePosition
            p = PBox_Camera.PointToClient(p)
            If p.X < -15 Then Return
            If Capture_Image Is Nothing Then
                Capture_Image = New Bitmap(160, 120)
            End If
            Dim g As Graphics = Graphics.FromImage(Capture_Image)
            g.Clear(Color.Black)
            Dim x As Single = CSng(p.X / PBox_Camera.Width)
            Dim y As Single = 1 - CSng(p.Y / PBox_Camera.Height)
            x *= g.VisibleClipBounds.Width
            y *= g.VisibleClipBounds.Height
            For i As Int32 = 16 To 1 Step -1
                Dim c As Int32 = 255 - i * 15
                Dim b As SolidBrush = New SolidBrush(Color.FromArgb(c, c, c))
                g.FillEllipse(b, x - i, y - i, i * 2, i * 2)
            Next
            ProcessImage_Captured()
            ProcessImage_ExtractBmpBytes()
        End If
    End Sub

End Class
