﻿Imports System.Drawing.Imaging
Imports System.Drawing.Drawing2D

Module Module_ImageFunctions

    Friend Sub ProcessImage_Contrast(ByRef img As Image)
        Dim imgAttr As ImageAttributes = New ImageAttributes()
        imgAttr.SetColorMatrix(New ColorMatrix(New Single()() _
                               {New Single() {2, 0, 0, 0, 0}, _
                                New Single() {0, 2, 0, 0, 0}, _
                                New Single() {0, 0, 2, 0, 0}, _
                                New Single() {0, 0, 0, 1, 0}, _
                                New Single() {0, 0, 0, 0, 1}}))
        Dim g As Graphics = Graphics.FromImage(img)
        Dim w As Integer = img.Width
        Dim h As Integer = img.Height
        Dim rec As Rectangle = New Rectangle(0, 0, w, h)
        g.DrawImage(img, rec, 0, 0, w, h, GraphicsUnit.Pixel, imgAttr)
    End Sub

    Friend Sub ProcessImage_Gray(ByRef img As Image)
        Dim imgAttr As ImageAttributes = New ImageAttributes()
        imgAttr.SetColorMatrix(New ColorMatrix(New Single()() _
                               {New Single() {0.299, 0.299, 0.299, 0, 0}, _
                                New Single() {0.587, 0.587, 0.587, 0, 0}, _
                                New Single() {0.114, 0.114, 0.114, 0, 0}, _
                                New Single() {0, 0, 0, 1, 0}, _
                                New Single() {0, 0, 0, 0, 1}}))
        Dim g As Graphics = Graphics.FromImage(img)
        Dim w As Integer = img.Width
        Dim h As Integer = img.Height
        Dim rec As Rectangle = New Rectangle(0, 0, w, h)
        g.DrawImage(img, rec, 0, 0, w, h, GraphicsUnit.Pixel, imgAttr)
    End Sub

    Friend Sub ProcessImage_Negative(ByRef img As Image)
        Dim imgAttr As ImageAttributes = New ImageAttributes()
        imgAttr.SetColorMatrix(New ColorMatrix(New Single()() _
                           {New Single() {-1, 0, 0, 0, 0}, _
                            New Single() {0, -1, 0, 0, 0}, _
                            New Single() {0, 0, -1, 0, 0}, _
                            New Single() {0, 0, 0, 1, 0}, _
                            New Single() {1, 1, 1, 1, 1}}))
        Dim g As Graphics = Graphics.FromImage(img)
        Dim w As Integer = img.Width
        Dim h As Integer = img.Height
        Dim rec As Rectangle = New Rectangle(0, 0, w, h)
        g.DrawImage(img, rec, 0, 0, w, h, GraphicsUnit.Pixel, imgAttr)
    End Sub

    'Friend Sub ProcessImage_Edge(ByRef img As Image)
    '    Dim imgAttr As ImageAttributes = New ImageAttributes()
    '    imgAttr.SetColorMatrix(New ColorMatrix(New Single()() _
    '                           {New Single() {1, 1, 1, 0, 0}, _
    '                            New Single() {1, 0, 1, 0, 0}, _
    '                            New Single() {1, 1, 1, 0, 0}, _
    '                            New Single() {0, 0, 0, 1, 0}, _
    '                            New Single() {0, 0, 0, 0, 1}}))
    '    Dim g As Graphics = Graphics.FromImage(img)
    '    Dim w As Integer = img.Width
    '    Dim h As Integer = img.Height
    '    Dim rec As Rectangle = New Rectangle(0, 0, w, h)
    '    g.DrawImage(img, rec, 0, 0, w, h, GraphicsUnit.Pixel, imgAttr)
    'End Sub

End Module
