
Imports System.Drawing.Imaging
Imports System.Drawing.Drawing2D
Imports System.Runtime.InteropServices

Module ProcessImage

    Private ci As Globalization.CultureInfo = Globalization.CultureInfo.InvariantCulture
    Private StopWatch1 As Stopwatch = New Stopwatch

    Private FlipX As Boolean
    Private FlipY As Boolean

    Private SrcImage As Image
    Private Millisec As Single

    Friend Sub ProcessImage_SetParams()
        FlipX = Form1.chk_FlipX.Checked
        FlipY = Form1.chk_FlipY.Checked
    End Sub

    ' ================================================================================
    '  PROCESS CAPTURED IMAGE
    ' ================================================================================
    Friend Sub ProcessImage_Captured()
        ' ----------------------------------------------------------------------- START TIMER
        StopWatch1.Reset()
        StopWatch1.Start()
        ' ----------------------------------------------------------------------- LOAD CAPTURED IMAGE
        SrcImage = Capture_Image
        'SrcImage = CType(Capture_Image.Clone, Image)
        ' ----------------------------------------------------------------------- FLIP X and Y
        If SrcImage Is Nothing Then Return
        If Not FlipY Then
            If FlipX Then
                SrcImage.RotateFlip(RotateFlipType.RotateNoneFlipXY)
            Else
                SrcImage.RotateFlip(RotateFlipType.RotateNoneFlipY)
            End If
        Else
            If FlipX Then
                SrcImage.RotateFlip(RotateFlipType.RotateNoneFlipX)
            Else

            End If
        End If

        'ProcessImage_Gray(SrcImage)
        'ProcessImage_Negative(SrcImage)
        'ProcessImage_Edge(SrcImage)
        'ProcessImage_Contrast(SrcImage)

        Millisec = StopWatch1.ElapsedMilliseconds
    End Sub

   

    Friend Sub ProcessImage_ToUserInterface()
        ' ----------------------------------------------------------------------- SHOW SOURCE IMAGE
        Try
            'Form1.PBox_Camera.Image = SrcImage
            Form1.PBox_Camera.BackgroundImage = CType(SrcImage.Clone, Image)
            ' ----------------------------------------------------------------------- SHOW IMAGE SIZE and TIME
            Form1.Label_Resolution.Text = SrcImage.Width.ToString & _
                                              " x " & SrcImage.Height.ToString
            Form1.Label_FramesPerSec.Text = Capture_FramesPerSecond.ToString("0") & " fps"
            ' -----------------------------------------------------------------------
            Form1.Label_Millisec.Text = Millisec.ToString("0") & " mS"
        Catch
        End Try
    End Sub

    Friend BmpH As Int32 = 20
    Friend BmpW As Int32 = 7
    Friend BmpStride As Int32
    Friend BmpByteCount As Int32
    Friend BmpBytes(-1) As Byte

    Friend Sub ProcessImage_ExtractBmpBytes()
        If SrcImage Is Nothing Then Return
        ' --------------------------------------------------------------------- reduce dimensions
        Dim bmp As New Bitmap(BmpW, BmpH, PixelFormat.Format24bppRgb)
        Dim g As Graphics = Graphics.FromImage(bmp)
        g.InterpolationMode = InterpolationMode.HighQualityBilinear
        g.DrawImage(SrcImage, 0, 0, BmpW, BmpH)

        'SrcImage = bmp

        ' --------------------------------------------------------------------- bytes to byte array
        Dim SourceData As BitmapData
        SourceData = bmp.LockBits(New Rectangle(0, 0, BmpW, BmpH), _
                                     ImageLockMode.ReadWrite, _
                                     PixelFormat.Format24bppRgb)
        BmpStride = SourceData.Stride
        BmpByteCount = BmpStride * BmpH
        If BmpBytes.Length <> BmpByteCount Then ReDim BmpBytes(BmpByteCount - 1)
        Marshal.Copy(SourceData.Scan0, BmpBytes, 0, BmpByteCount)
        bmp.UnlockBits(SourceData)
    End Sub


End Module
